#include "StdAfx.h"
#include "AddinModule.h"

using namespace System::Reflection;

namespace AdxHT_003_VC
{
    //Add-in Module Implementation

	Outlook::_Application* AddinModule::OutlookHost()
	{
		return __try_cast<Outlook::_Application *>(HostApplication);
	}


	void AddinModule::DoStartupComplete(System::Object *  sender, System::EventArgs *  e)
	{
	}

    void AddinModule::DoBeginShutdown(System::Object *  sender, System::EventArgs *  e)
	{
	}
    
	void AddinModule::DoSelectionChange(void)
	{
		Outlook::Inspector* ActiveInspector;
        ActiveInspector = 0;

		try
		{
			System::Object* CurrentItem;
            CurrentItem = 0;
			ActiveInspector = OutlookHost()->ActiveInspector();
			 
			if ((ActiveInspector != 0) && (dynamic_cast<Outlook::Inspector*>(OutlookHost()->ActiveWindow()) != 0 ))
			{
				CurrentItem = ActiveInspector->CurrentItem;
			}
			else
			{
				Outlook::Explorer* ActiveExplorer = OutlookHost()->ActiveExplorer();
				Outlook::Selection* SelItem = ActiveExplorer->Selection;
                if (SelItem->Count > 0) 
				{
                    CurrentItem = SelItem->Item(__box(1));
					Marshal::ReleaseComObject(SelItem);
					Marshal::ReleaseComObject(ActiveExplorer);
				}
			}
            if (CurrentItem != 0) 
			{
                int ItemClass; 
				ItemClass = Convert::ToInt32(CurrentItem->GetType()->InvokeMember("Class", BindingFlags::GetProperty, 0, CurrentItem, 0));
				if (ItemClass == Outlook::OlObjectClass::olMail) 
                    DoMyActionOnSelectionChange(CurrentItem);
				Marshal::ReleaseComObject(CurrentItem);
			}
		}
		catch(System::Exception*)
		{
		}

        if (ActiveInspector != 0) 
		{
            Marshal::ReleaseComObject(ActiveInspector);
		}

	}

	void AddinModule::DoMyActionOnSelectionChange(System::Object* item)
	{
		try
		{
			System::String* EntryID = Convert::ToString(item->GetType()->InvokeMember("EntryID", BindingFlags::GetProperty, 0, item, 0));
			if (LastEntryID != EntryID) 
			{
				System::String* Subject = Convert::ToString(item->GetType()->InvokeMember("Subject", BindingFlags::GetProperty, 0, item, 0));
                MessageBox::Show(Subject, "SelectionChange (VC)", MessageBoxButtons::OK, MessageBoxIcon::Information); 
                LastEntryID = EntryID;
			}

		}
        catch(System::Exception*)
		{
		}

	}


}

